std::ios_base(3)

NAME
std::ios_base -

SYNOPSIS

Inherited by basic_ios.

Detailed Description

This class defines everything that can be defined about I/O that does not depend on the type of characters being input or output. Most people will only see ios_base when they need to specify the full name of the various I/O flags (e.g., the openmodes).

Definition at line 201 of file ios_base.h.

  Public Types
copyfmt_event
erase_event
enum event { erase_event, imbue_event, copyfmt_event }
typedef void(*) event_callback (event, ios_base &, int)
typedef _Ios_Fmtflags fmtflags
imbue_event
typedef int io_state
typedef _Ios_Iostate iostate
typedef int open_mode
typedef _Ios_Openmode openmode
typedef int seek_dir
typedef _Ios_Seekdir seekdir
typedef std::streamoff streamoff
typedef std::streampos streampos

  Public Member Functions
const locale & _M_getloc () const
fmtflags flags (fmtflags __fmtfl)
fmtflags flags () const
locale getloc () const
locale imbue (const locale &__loc)
long & iword (int __ix)
streamsize precision (streamsize __prec)
streamsize precision () const
void *& pword (int __ix)
void register_callback (event_callback __fn, int __index)
fmtflags setf (fmtflags __fmtfl, fmtflags __mask)
fmtflags setf (fmtflags __fmtfl)
void unsetf (fmtflags __mask)
streamsize width (streamsize __wide)
streamsize width () const
virtual ~ios_base ()

  Static Public Member Functions
static bool sync_with_stdio (bool __sync=true)
static int xalloc () throw ()

  Static Public Attributes
static const fmtflags adjustfield
static const openmode app
static const openmode ate
static const iostate badbit
static const fmtflags basefield
static const seekdir beg
static const openmode binary
static const fmtflags boolalpha
static const seekdir cur
static const fmtflags dec
static const seekdir end
static const iostate eofbit
static const iostate failbit
static const fmtflags fixed
static const fmtflags floatfield
static const iostate goodbit
static const fmtflags hex
static const openmode in
static const fmtflags internal
static const fmtflags left
static const fmtflags oct
static const openmode out
static const fmtflags right
static const fmtflags scientific
static const fmtflags showbase
static const fmtflags showpoint
static const fmtflags showpos
static const fmtflags skipws
static const openmode trunc
static const fmtflags unitbuf
static const fmtflags uppercase

  Protected Types
enum { _S_local_word_size }
_S_local_word_size

  Protected Member Functions
void _M_call_callbacks (event __ev) throw ()
void _M_dispose_callbacks (void)
_Words & _M_grow_words (int __index, bool __iword)
void _M_init ()

  Protected Attributes
_Callback_list * _M_callbacks
locale _M_ios_locale
_Words _M_local_word [_S_local_word_size]
_Words * _M_word
int _M_word_size
_Words _M_word_zero

iostate _M_exception
fmtflags _M_flags
streamsize _M_precision
iostate _M_streambuf_state
streamsize _M_width

  Classes
struct _Callback_list
struct _Words
class failure
These are thrown to indicate problems. Doc me.
class Init

Member Typedef Documentation

  typedef void(*) event_callback(event, ios_base &, int)

The type of an event callback function.

Parameters:
    event One of the members of the event enum.
    ios_base Reference to the ios_base object.
    int The integer provided when the callback was registered.

Event callbacks are user defined functions that get called during several ios_base and basic_ios functions, specifically imbue(), copyfmt(), and ~ios().

Definition at line 435 of file ios_base.h.

  typedef _Ios_Fmtflags fmtflags

This is a bitmask type.

'_Ios_Fmtflags' is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type fmtflags are:

•   boolalpha

•   dec

•   fixed

•   hex

•   internal

•   left

•   oct

•   right

•   scientific

•   showbase

•   showpoint

•   showpos

•   skipws

•   unitbuf

•   uppercase

•   adjustfield

•   basefield

•   floatfield

Definition at line 253 of file ios_base.h.

  typedef _Ios_Iostate iostate

This is a bitmask type.

'_Ios_Iostate' is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type iostate are:

•   badbit

•   eofbit

•   failbit

•   goodbit

Definition at line 328 of file ios_base.h.

  typedef _Ios_Openmode openmode

This is a bitmask type.

'_Ios_Openmode' is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type openmode are:

•   app

•   ate

•   binary

•   in

•   out

•   trunc

Definition at line 359 of file ios_base.h.

  typedef _Ios_Seekdir seekdir

This is an enumerated type.

'_Ios_Seekdir' is implementation-defined. Defined values of type seekdir are:

•   beg

•   cur, equivalent to SEEK_CUR in the C standard library.

•   end, equivalent to SEEK_END in the C standard library.

Definition at line 392 of file ios_base.h.

Member Enumeration Documentation

  enum event

The set of events that may be passed to an event callback.

erase_event is used during ~ios() and copyfmt(). imbue_event is used during imbue(). copyfmt_event is used during copyfmt().

Definition at line 418 of file ios_base.h.

Constructor & Destructor Documentation

  virtual ~ios_base () [virtual]

Invokes each callback with erase_event. Destroys local storage.

Note that the ios_base object for the standard streams never gets destroyed. As a result, any callbacks registered with the standard streams will not get invoked with erase_event (unless copyfmt is used).

Member Function Documentation

  const locale& _M_getloc () const [inline]

Locale access.

Returns:
    A reference to the current locale.

Like getloc above, but returns a reference instead of generating a copy.

Definition at line 700 of file ios_base.h.

References ios_base::_M_ios_locale.

Referenced by money_get::_M_extract(), num_get::_M_extract_float(), num_get::_M_extract_int(), time_get::_M_extract_name(), time_get::_M_extract_num(), time_get::_M_extract_via_format(), money_put::_M_insert(), num_put::_M_insert_float(), num_put::_M_insert_int(), __pad::_S_pad(), money_get::do_get(), num_get::do_get(), time_get::do_get_date(), time_get::do_get_monthname(), time_get::do_get_time(), time_get::do_get_weekday(), time_get::do_get_year(), time_put::do_put(), num_put::do_put(), and time_put::put().

  fmtflags flags (fmtflags __fmtfl) [inline]

Setting new format flags all at once.

Parameters:
    fmtfl The new flags to set.

Returns:
    The previous format control flags.

This function overwrites all the format flags with fmtfl.

Definition at line 558 of file ios_base.h.

References ios_base::_M_flags.

  fmtflags flags () const [inline]

Access to format flags.

Returns:
    The format control flags for both input and output.

Definition at line 548 of file ios_base.h.

References ios_base::_M_flags.

Referenced by money_get::_M_extract(), num_get::_M_extract_int(), money_put::_M_insert(), num_put::_M_insert_float(), num_put::_M_insert_int(), __pad::_S_pad(), basic_ios::copyfmt(), num_get::do_get(), num_put::do_put(), __gnu_cxx::operator<<(), basic_ostream::operator<<(), and basic_istream::sentry::sentry().

  locale getloc () const [inline]

Locale access.

Returns:
    A copy of the current locale.

If imbue(loc) has previously been called, then this function returns loc. Otherwise, it returns a copy of std::locale(), the global C++ locale.

Definition at line 690 of file ios_base.h.

References ios_base::_M_ios_locale.

Referenced by basic_ios::copyfmt(), money_put::do_put(), std::operator>>(), and std::ws().

  locale imbue (const locale & __loc)

Setting a new locale.

Parameters:
    loc The new locale.

Returns:
    The previous locale.

Sets the new locale for this stream, and then invokes each callback with imbue_event.

Reimplemented in basic_ios.

Referenced by basic_ios::imbue().

  long& iword (int __ix) [inline]

Access to integer array.

Parameters:
    __ix Index into the array.

Returns:
    A reference to an integer associated with the index.

The iword function provides access to an array of integers that can be used for any purpose. The array grows as required to hold the supplied index. All integers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

Definition at line 734 of file ios_base.h.

References ios_base::_Words::_M_iword, ios_base::_M_word, and ios_base::_M_word_size.

  streamsize precision (streamsize __prec) [inline]

Changing flags.

Parameters:
    prec The new precision value.

Returns:
    The previous value of precision().

Definition at line 626 of file ios_base.h.

References ios_base::_M_precision.

  streamsize precision () const [inline]

Flags access.

Returns:
    The precision to generate on certain output operations.

Definition at line 618 of file ios_base.h.

References ios_base::_M_precision.

Referenced by num_put::_M_insert_float(), basic_ios::copyfmt(), std::operator<<(), and std::operator>>().

  void*& pword (int __ix) [inline]

Access to void pointer array.

Parameters:
    __ix Index into the array.

Returns:
    A reference to a void* associated with the index.

The pword function provides access to an array of pointers that can be used for any purpose. The array grows as required to hold the supplied index. All pointers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

Definition at line 755 of file ios_base.h.

References ios_base::_Words::_M_pword, ios_base::_M_word, and ios_base::_M_word_size.

  void register_callback (event_callback __fn, int __index)

Add the callback __fn with parameter __index.

Parameters:
    __fn The function to add.
    __index The integer to pass to the function when invoked.

Registers a function as an event callback with an integer parameter to be passed to the function when invoked. Multiple copies of the function are allowed. If there are multiple callbacks, they are invoked in the order they were registered.

  fmtflags setf (fmtflags __fmtfl, fmtflags __mask) [inline]

Setting new format flags.

Parameters:
    fmtfl Additional flags to set.
    mask The flags mask for fmtfl.

Returns:
    The previous format control flags.

This function clears mask in the format flags, then sets fmtfl & mask. An example mask is ios_base::adjustfield.

Definition at line 591 of file ios_base.h.

References ios_base::_M_flags.

  fmtflags setf (fmtflags __fmtfl) [inline]

Setting new format flags.

Parameters:
    fmtfl Additional flags to set.

Returns:
    The previous format control flags.

This function sets additional flags in format control. Flags that were previously set remain set.

Definition at line 574 of file ios_base.h.

References ios_base::_M_flags.

Referenced by std::boolalpha(), std::dec(), std::fixed(), std::hex(), std::internal(), std::left(), std::oct(), std::operator<<(), std::operator>>(), std::right(), std::scientific(), std::showbase(), std::showpoint(), std::showpos(), std::skipws(), std::unitbuf(), and std::uppercase().

  static bool sync_with_stdio (bool __sync = true) [static]

Interaction with the standard C I/O objects.

Parameters:
    sync Whether to synchronize or not.

Returns:
    True if the standard streams were previously synchronized.

The synchronization referred to is only that between the standard C facilities (e.g., stdout) and the standard C++ objects (e.g., cout). User-declared streams are unaffected. See http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#8 for more.

  void unsetf (fmtflags __mask) [inline]

Clearing format flags.

Parameters:
    mask The flags to unset.

This function clears mask in the format flags.

Definition at line 606 of file ios_base.h.

References ios_base::_M_flags.

Referenced by std::noboolalpha(), std::noshowbase(), std::noshowpoint(), std::noshowpos(), std::noskipws(), std::nounitbuf(), and std::nouppercase().

  streamsize width (streamsize __wide) [inline]

Changing flags.

Parameters:
    wide The new width value.

Returns:
    The previous value of width().

Definition at line 648 of file ios_base.h.

References ios_base::_M_width.

  streamsize width () const [inline]

Flags access.

Returns:
    The minimum field width to generate on output operations.

Definition at line 640 of file ios_base.h.

References ios_base::_M_width.

Referenced by money_put::_M_insert(), num_put::_M_insert_float(), num_put::_M_insert_int(), basic_ios::copyfmt(), num_put::do_put(), __gnu_cxx::operator<<(), std::operator<<(), and std::operator>>().

  static int xalloc () throw () [static]

Access to unique indices.

Returns:
    An integer different from all previous calls.

This function returns a unique integer every time it is called. It can be used for any purpose, but is primarily intended to be a unique index for the iword and pword functions. The expectation is that an application calls xalloc in order to obtain an index in the iword and pword arrays that can be used without fear of conflict.

The implementation maintains a static variable that is incremented and returned on each invocation. xalloc is guaranteed to return an index that is safe to use in the iword and pword arrays.

Member Data Documentation

  const fmtflags adjustfield [static]

A mask of left|right|internal. Useful for the 2-arg form of setf.

Definition at line 308 of file ios_base.h.

Referenced by money_put::_M_insert(), __pad::_S_pad(), std::internal(), std::left(), and std::right().

  const openmode app [static]

Seek to end before each write.

Definition at line 362 of file ios_base.h.

Referenced by basic_stringbuf::_M_stringbuf_init().

  const openmode ate [static]

Open and seek to end immediately after opening.

Definition at line 365 of file ios_base.h.

Referenced by basic_stringbuf::_M_stringbuf_init(), and basic_filebuf::open().

  const iostate badbit [static]

as an irrecoverable read error from a file).

Definition at line 332 of file ios_base.h.

Referenced by basic_ostream::_M_write(), basic_ios::bad(), basic_ios::clear(), basic_ios::fail(), basic_ostream::flush(), basic_istream::get(), std::getline(), basic_istream::getline(), basic_istream::ignore(), basic_ios::init(), std::operator<<(), basic_ostream::operator<<(), basic_istream::operator>>(), std::operator>>(), basic_istream::peek(), basic_ostream::put(), basic_istream::putback(), basic_istream::read(), basic_istream::readsome(), basic_istream::seekg(), basic_ostream::seekp(), basic_istream::sync(), basic_istream::tellg(), basic_ostream::tellp(), basic_istream::unget(), basic_ostream::write(), and basic_ostream::sentry::~sentry().

  const fmtflags basefield [static]

A mask of dec|oct|hex. Useful for the 2-arg form of setf.

Definition at line 311 of file ios_base.h.

Referenced by std::__int_to_char(), num_get::_M_extract_int(), num_put::_M_insert_int(), std::dec(), num_get::do_get(), num_put::do_put(), std::hex(), std::oct(), basic_ostream::operator<<(), std::operator<<(), and std::operator>>().

  const seekdir beg [static]

Request a seek relative to the beginning of the stream.

Definition at line 395 of file ios_base.h.

Referenced by stdio_sync_filebuf::seekoff(), stdio_sync_filebuf::seekpos(), and basic_filebuf::seekpos().

  const openmode binary [static]

http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#7 for more.

Definition at line 371 of file ios_base.h.

Referenced by basic_filebuf::showmanyc().

  const fmtflags boolalpha [static]

Insert/extract bool in alphabetic rather than numeric format.

Definition at line 256 of file ios_base.h.

Referenced by std::boolalpha(), num_get::do_get(), num_put::do_put(), and std::noboolalpha().

  const seekdir cur [static]

Request a seek relative to the current position within the sequence.

Definition at line 398 of file ios_base.h.

Referenced by basic_filebuf::imbue(), basic_filebuf::pbackfail(), stdio_sync_filebuf::seekoff(), basic_stringbuf::seekoff(), basic_filebuf::seekoff(), basic_istream::tellg(), and basic_ostream::tellp().

  const fmtflags dec [static]

Converts integer input or generates integer output in decimal base.

Definition at line 259 of file ios_base.h.

Referenced by std::dec(), std::operator<<(), and std::operator>>().

  const seekdir end [static]

Request a seek relative to the current end of the sequence.

Definition at line 401 of file ios_base.h.

Referenced by basic_filebuf::open(), and basic_stringbuf::seekoff().

  const iostate eofbit [static]

Indicates that an input operation reached the end of an input sequence.

Definition at line 335 of file ios_base.h.

Referenced by money_get::_M_extract(), num_get::_M_extract_float(), num_get::_M_extract_int(), num_get::do_get(), time_get::do_get_date(), time_get::do_get_monthname(), time_get::do_get_time(), time_get::do_get_weekday(), time_get::do_get_year(), basic_ios::eof(), basic_istream::get(), std::getline(), basic_istream::getline(), basic_istream::ignore(), std::operator>>(), basic_istream::peek(), basic_istream::read(), basic_istream::readsome(), basic_istream::sentry::sentry(), and std::ws().

  const iostate failbit [static]

desired characters.

Definition at line 340 of file ios_base.h.

Referenced by money_get::_M_extract(), num_get::_M_extract_float(), num_get::_M_extract_int(), time_get::_M_extract_name(), time_get::_M_extract_num(), time_get::_M_extract_via_format(), basic_fstream::close(), basic_ofstream::close(), basic_ifstream::close(), num_get::do_get(), time_get::do_get_monthname(), time_get::do_get_weekday(), time_get::do_get_year(), basic_ios::fail(), basic_istream::get(), std::getline(), basic_istream::getline(), basic_fstream::open(), basic_ofstream::open(), basic_ifstream::open(), basic_ostream::operator<<(), basic_istream::operator>>(), std::operator>>(), basic_istream::read(), basic_istream::seekg(), basic_ostream::seekp(), basic_ostream::sentry::sentry(), and basic_istream::sentry::sentry().

  const fmtflags fixed [static]

Generate floating-point output in fixed-point notation.

Definition at line 262 of file ios_base.h.

Referenced by num_put::_M_insert_float(), and std::fixed().

  const fmtflags floatfield [static]

A mask of scientific|fixed. Useful for the 2-arg form of setf.

Definition at line 314 of file ios_base.h.

Referenced by std::fixed(), and std::scientific().

  const iostate goodbit [static]

Indicates all is well.

Definition at line 343 of file ios_base.h.

Referenced by basic_ostream::flush(), basic_istream::get(), std::getline(), basic_istream::getline(), basic_istream::ignore(), basic_ios::init(), basic_ostream::operator<<(), basic_istream::operator>>(), std::operator>>(), basic_istream::peek(), basic_ostream::put(), basic_istream::putback(), basic_istream::read(), basic_istream::readsome(), basic_istream::seekg(), basic_ostream::seekp(), basic_istream::sentry::sentry(), basic_istream::sync(), and basic_istream::unget().

  const fmtflags hex [static]

Converts integer input or generates integer output in hexadecimal base.

Definition at line 265 of file ios_base.h.

Referenced by std::__int_to_char(), num_get::_M_extract_int(), num_put::_M_insert_int(), num_get::do_get(), num_put::do_put(), std::hex(), basic_ostream::operator<<(), std::operator<<(), and std::operator>>().

  const openmode in [static]

Open for input. Default for ifstream and fstream.

Definition at line 374 of file ios_base.h.

Referenced by basic_filebuf::_M_set_buffer(), basic_stringbuf::_M_sync(), basic_stringbuf::_M_update_egptr(), basic_ifstream::open(), basic_filebuf::pbackfail(), basic_istream::seekg(), basic_stringbuf::seekoff(), basic_stringbuf::seekpos(), basic_stringbuf::showmanyc(), basic_filebuf::showmanyc(), basic_istream::tellg(), basic_stringbuf::underflow(), basic_filebuf::underflow(), and basic_filebuf::xsgetn().

  const fmtflags internal [static]

designated.

Definition at line 270 of file ios_base.h.

Referenced by money_put::_M_insert(), __pad::_S_pad(), num_put::do_put(), and std::internal().

  const fmtflags left [static]

generated output. (I.e., the thing you print is flush left.)

Definition at line 274 of file ios_base.h.

Referenced by money_put::_M_insert(), __pad::_S_pad(), std::left(), and __gnu_cxx::operator<<().

  const fmtflags oct [static]

Converts integer input or generates integer output in octal base.

Definition at line 277 of file ios_base.h.

Referenced by std::__int_to_char(), num_get::_M_extract_int(), num_put::_M_insert_int(), std::oct(), basic_ostream::operator<<(), std::operator<<(), and std::operator>>().

  const openmode out [static]

Open for output. Default for ofstream and fstream.

Definition at line 377 of file ios_base.h.

Referenced by basic_filebuf::_M_set_buffer(), basic_stringbuf::_M_sync(), basic_ofstream::open(), basic_stringbuf::overflow(), basic_filebuf::overflow(), basic_stringbuf::pbackfail(), basic_stringbuf::seekoff(), basic_ostream::seekp(), basic_stringbuf::seekpos(), basic_ostream::tellp(), and basic_filebuf::xsputn().

  const fmtflags right [static]

generated output. (I.e., the thing you print is flush right.)

Definition at line 281 of file ios_base.h.

Referenced by std::right().

  const fmtflags scientific [static]

Generates floating-point output in scientific notation.

Definition at line 284 of file ios_base.h.

Referenced by std::scientific().

  const fmtflags showbase [static]

output.

Definition at line 288 of file ios_base.h.

Referenced by money_get::_M_extract(), money_put::_M_insert(), num_put::_M_insert_int(), num_put::do_put(), std::noshowbase(), and std::showbase().

  const fmtflags showpoint [static]

floating-point output.

Definition at line 292 of file ios_base.h.

Referenced by std::noshowpoint(), and std::showpoint().

  const fmtflags showpos [static]

Generates a + sign in non-negative generated numeric output.

Definition at line 295 of file ios_base.h.

Referenced by num_put::_M_insert_int(), std::noshowpos(), and std::showpos().

  const fmtflags skipws [static]

Skips leading white space before certain input operations.

Definition at line 298 of file ios_base.h.

Referenced by std::noskipws(), basic_istream::sentry::sentry(), and std::skipws().

  const openmode trunc [static]

Open for input. Default for ofstream.

Definition at line 380 of file ios_base.h.

  const fmtflags unitbuf [static]

Flushes output after each output operation.

Definition at line 301 of file ios_base.h.

Referenced by std::nounitbuf(), std::unitbuf(), and basic_ostream::sentry::~sentry().

  const fmtflags uppercase [static]

in generated output.

Definition at line 305 of file ios_base.h.

Referenced by std::__int_to_char(), num_put::_M_insert_int(), num_put::do_put(), std::nouppercase(), and std::uppercase().

Author

Generated automatically by Doxygen for libstdc++ from the source code.